=== debian/changelog ===
strawberry (0.6.10-0.1~mx19+1) mx; urgency=medium

  * Import new upstream release:
    - Removed Phonon engine support.
    - Added back Tidal streaming support.
    - Added Qobuz album cover provider.
    - Fixed Subsonic album covers not working for albums with non ASCII
      characters.
    - Fixed reading date and genre from individual tracks in CUE sheets.
    - Fixed resume playback on startup for CUE songs.
    - Fixed album cover manager not showing complete album titles in the list
      of album covers.
    - Fixed save album cover to file saving "no cover" image instead of actual
      album cover.
    - Fixed device state text color in devices not being visible when using a
      dark theme.
    - Fixed engine and device in context using too large icons when icons were
      loaded from the system theme.
    - Fixed "Secure connection setup failed" problem on Windows when playing
      streams.
    - Fixed margin for song title text in context.
    - Fixed UNC paths with non ASCII charcters not working.
    - Allowing all characters except slash and backslash when organising music
      unless options to strip characters is checked.
    - New option in organising music to remove problematic filename characters
      that removes less characters than the FAT option.
    - General improvements to the album cover loader and album cover providers
      code.
    - Fixed loading album cover images from album directory for songs added to
      the playlist from outside of the collection.
    - Made automatic album cover search work for songs outside of the collection
      and for streams.
    - Made album cover search work based on artist + title if album title is not
      present for providers supporting song/track search.
    - Update art manual in playlist for local files, devices and CDDA to avoid
      loading covers multiple times.
    - Made lyrics search work for streams.
    - Added "add stream" to menu.
    - Only showing song length in context when available.
    - Sort album cover search results by score and pick the best 3 first before
      trying others to improve album cover search speed.
    - Make scrobbler work for streams.
    - Added search for lyrics as a seperate option in context.
    - Made font and font sizes in context configurable.
    - Splitting artist and song title to the relevant metadata when artist and
      song title is sent as title seperated by a dash in streams.
    - Added label to show collection pixmap disk cache used in settings.
    - Icreased default collection pixmap disk cache to 360.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 08 May 2020 06:57:31 -0700

strawberry (0.6.9-0.1~mx19+1) mx; urgency=medium

  * Import new upstream release:
    - BugFixes:
      - Fixed playlist metadata updating interfering with manual tag editing.
      -  Fixed order of tabs in all windows.
      -  Fixed playlist right click using wrong songs for determining menu
         options when playlist was filtered.
      -  Fixed possible crashes on playlist right click.
      -  Fixed possible null pointer crash in OSD pretty.
      -  Fixed track and title in playlist not being movable.
      -  Fixed Subsonic support to handle numeric Json values like track and
         disc both as strings and integers.
      -  Fixed Subsonic compatibility with LMS (Lightweight Music Server).
      -  Disabled "open Audio CD" from menu on Windows where CD support is
         currently not supported.
      -  Fixed files containing "MAC" being detected as Monkey's Audio.
    - Enhancements:
      -  Improved support for High DPI displays.
      -  Added CMake check for backtrace() to fix compilation with musl libc.
      -  Made album cover in context adjust to width.
      -  Made settings, cover manager, organise dialog and transcode music
         dialog center on the same display where the mainwindow is located.
      -  Removing empty directories when organizing music.
      -  Made file selection work in "Show file in browser" for Dolphin and
         Nautilus.
      -  Implemented disk caching of album thumbnails in collection tree.
      -  Use a shorter playlist name when songs are added from file view.
      -  Disabled optical drives in copy to device menu.
      -  Added better error handling for CDDA loading.
      -  Added Polish, Hungarian and Korean translations.
    - Removed features:
      -  Chartlyrics support (Unstable API).
      -  Tidal support (No agreement).
      -  QObuz support (No agreement).

  * Drop debian/patches: fixed upstream.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 23 Apr 2020 09:47:24 -0700
